{ This program is a random number generator for BEN-ARI's concurrent PASCAL-S
  interpreter. 'Problem Solving Using Pascal, R. Skvarcius, PWS Publishers 1984
  pages 348-349                                       F. P. Genc ... 29.10.1995

  The program generates 2500 numbers in the range 1-max (20) and prints the
  distribution. 

}
 
program random_gen;

const no_of_seeds = 100;
      max = 20;

var i     : integer;
    seed  : array[1..no_of_seeds] of integer;
    dist  : array[1..max] of integer;
    ran   : integer;

function random(seed_no:integer;l_bound:integer;u_bound:integer) :integer;
var ran     :integer;
begin
   seed[seed_no]:=(seed[seed_no]*13077 + 6925) mod(32768);
   ran := (seed[seed_no] * 10000) div 32768;
   {writeln(' seed : ',seed[seed_no],' ran : ',ran,'    ');}
   random := l_bound + ((u_bound - l_bound + 1) * ran) div 10000;
end;

begin {main}
   for i:= 1 to no_of_seeds do seed[i]:=6997*i;
   for i:= 1 to max do dist[i]:=0;
   for i:= 1 to 2500 do begin
                           ran:= random(1,1,max);
                           dist[ran]:=dist[ran]+1;
                        end;
   for i:= 1 to max do writeln('  [',i,'] = ', dist[i]);
end.

