{ CEng 534 .. Midterm 2 .. 6 January 1988 .. m2_qx_88.cp 
  Solution of dining philosophers problem. In the solution a philosopher
  returns the left fork if right fork is not available at that time.
}

program m2_Q1;

const no_of_seeds = 2;
var fork  : array[0..4] of semaphore;
    i     : integer;
    mutex : semaphore;
    seed  : array[1..no_of_seeds] of integer;

function random(seed_no:integer;l_bound:integer;u_bound:integer) :integer;
var ran     :integer;
begin
   seed[seed_no]:=(seed[seed_no]*13077 + 6925) mod(32768);
   ran := (seed[seed_no] * 10000) div 32768;
   random := l_bound + ((u_bound - l_bound + 1) * ran) div 10000;
end;

procedure think;
var i : integer;
begin for i:= 1 to random(1,10,100) do end;

procedure eat;
var i : integer;
begin for i:= 1 to random(2,1,50) do end;

procedure ph(i:integer);
var j     : integer;
    flag  : boolean;
begin
    j:= (i+1) mod 5; {right fork index} 
    repeat
       think;
       flag:= true;
       while flag do 
          begin
             wait(fork[i]); {pick left fork} 
             wait(mutex); 
                writeln('philosopher : ',i,' lifts    left  fork');
             signal(mutex);
             if fork[j] = 0 
                then begin
                        signal(fork[i]); {right fork in use, return left fork}
                        wait(mutex); 
                           writeln('philosopher : ',i,' returns  left  fork');
                        signal(mutex);
                     end 
                else begin
                        wait(fork[j]); flag:= false; {pick right fork}
                        wait(mutex);
                           write('philosopher : ',i,' picks up right fork');
                           writeln(' AND STARTS EATING');
                        signal(mutex);
                    end;
          end;
       eat;
       signal(fork[i]); signal(fork[j]); {return both forks .. finish eating}  
       wait(mutex);
         writeln('philosopher : ',i,' returns  both  forks .. EATING IS OVER!');
       signal(mutex); 
   until false;
end;

begin {main}
   for i:= 1 to no_of_seeds do seed[i]:=6997*i;
   for i:= 0 to 4 do fork[i]:= 1;  mutex:= 1;
   cobegin for i:= 0 to 4 do ph(i) coend;
end.

