{ m1_q3_93.cp
  Ceng 534 Operating Systems Midterm 1 Question 3  ...  November 30, 1993

  Consider three processes p1, p2, and p3. How you implement a 3-way rendezvous
  to synchronize these processes using the concurrent Pascal kit of Ben-Ari.
  
}
program synchronization;

const  n = 3;
       no_of_seeds = 100;

var 
    s         : array[1..n] of semaphore;
    screen    : semaphore;  {controls screen display mutex}
    seed      : array[1..no_of_seeds] of integer;
    i         : integer;

function random(seed_no:integer;l_bound:integer;u_bound:integer) :integer;
var ran     :integer;
begin
   seed[seed_no]:=(seed[seed_no]*13077 + 6925) mod(32768);
   ran := (seed[seed_no] * 10000) div 32768;
   random := l_bound + ((u_bound - l_bound + 1) * ran) div 10000;
end;

procedure p(i :integer);
var j,k,r :integer;
begin
   while true do
      begin
        r:= random(i,1000,10000);
        wait(screen); 
           writeln('Process ',i,' is executing for ',r,' units'); 
        signal(screen);
        k:=0;  for j:= 1 to r do k:= k+ 1;   
        wait(screen); 
           writeln('Process ',i,' is waiting for others ..'); 
        signal(screen);

        for j:= 1 to n do if j <> i then signal(s[j]);
        for j:= 1 to n-1 do wait(s[i]);

        wait(screen);
           writeln('Process ',i,' has made the rendezvous ..');
        signal(screen);
    end;
end;

begin {main}
   for i:= 1 to no_of_seeds do seed[i]:=6997*i;
   for i:= 1 to n do s[i]:=0;
   screen:= 1;
   cobegin for i:= 1 to n do p(i) coend;
end.

